-- Hyper Sonic by Sls64LGamingBro


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	    if (player.speed >= FixedMul(player.runspeed, player.mo.scale))
	    and not player.powers[pw_super]
           local hypertrail = P_SpawnGhostMobj(player.mo)
	       hypertrail.color = player.mo.color
           hypertrail.fuse = 4
	       hypertrail.rollangle = player.mo.rollangle
		end   
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_sneakers] > 0
	and not player.powers[pw_super]
	and not ultimatemode
	     player.powers[pw_sneakers] = 0
		 P_GivePlayerRings(player, 3)
		 P_RestoreMusic(player)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_shield] > 0
	and not player.powers[pw_super]
	and not ultimatemode
	     player.powers[pw_shield] = 0
		 P_GivePlayerRings(player, 5)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_invulnerability] > 0
	and not player.powers[pw_super]
	and not ultimatemode
	     player.powers[pw_invulnerability] = 0
		 P_GivePlayerRings(player, 7)
		 P_RestoreMusic(player)
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_sneakers] > 0
	and not player.powers[pw_super]
	and ultimatemode
	     player.powers[pw_sneakers] = 0
		 P_GivePlayerRings(player, 1)
		 P_RestoreMusic(player)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_shield] > 0
	and not player.powers[pw_super]
	and ultimatemode
	     player.powers[pw_shield] = 0
		 P_GivePlayerRings(player, 2)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and player.powers[pw_invulnerability] > 0
	and not player.powers[pw_super]
	and ultimatemode
	     player.powers[pw_invulnerability] = 0
		 P_GivePlayerRings(player, 3)
		 P_RestoreMusic(player)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "hypersonic")
	and (player.rings < 1)
	and not netgame
	and not splitscreen
	and not player.powers[pw_super]
		 P_DamageMobj(player.mo, nil, nil, 0, DMG_INSTAKILL)
	end
end)


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "hypersonic")
	and not (player.pflags & PF_THOKKED)
		P_NukeEnemies(player.mo, player.mo, 1000*FRACUNIT)
		S_StartSound(player.mo, sfx_s3kb6)
		P_FlashPal(player, PAL_WHITE, 5)
		P_Thrust(player.mo, player.mo.angle, 25*FRACUNIT)
		player.pflags = $|PF_THOKKED 
	end
end)



addHook("ThinkFrame", function()
	for player in players.iterate do
	if not (player.mo and (player.mo.skin == "hypersonic")) then return end
		if (player.pflags & PF_JUMPED)
		and (player.cmd.buttons & BT_SPIN)
		and not (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
		and not (player.mo.state == S_PLAY_SUPER_TRANS2)
		and not (player.mo.state == S_PLAY_SUPER_TRANS3)
		and not (player.mo.state == S_PLAY_SUPER_TRANS4)
		and not (player.mo.state == S_PLAY_SUPER_TRANS5)
        and (P_IsObjectOnGround(player.mo) == false)
		   P_SetObjectMomZ(player.mo, 0*FRACUNIT)
		   player.mo.state = S_PLAY_FLOAT
		end
	end
end)


addHook("PlayerCanDamage", function(player, mobj)
    if player.mo and player.mo.skin == "hypersonic" and not P_PlayerInPain(player)
	and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS) return true end
end, MT_PLAYER)


addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and target.skin == "hypersonic" 
	and not (damagetype & DMG_DEATHMASK) 
		return true
	end
end, MT_PLAYER)


addHook("MobjDamage", function(target, inflictor, source, player)
	if inflictor.skin == "hypersonic"
		for player in players.iterate
			if (inflictor and inflictor.valid and inflictor.type == MT_PLAYER)
			and player.mo and player.mo.valid
			and not netgame
			and not splitscreen
			and not ultimatemode
			and (target.flags & MF_ENEMY)
			    P_GivePlayerRings(inflictor.player, 4)
			end
		end
	end
end)


addHook("MobjDamage", function(target, inflictor, source, player)
	if inflictor.skin == "hypersonic"
		for player in players.iterate
			if (inflictor and inflictor.valid and inflictor.type == MT_PLAYER)
			and player.mo and player.mo.valid
			and (target.flags & MF_BOSS)
			and not netgame
			and not splitscreen
			and not ultimatemode
			    P_GivePlayerRings(inflictor.player, 6)
			end
		end
	end
end)


addHook("MobjDamage", function(target, inflictor, source, player)
	if inflictor.skin == "hypersonic"
		for player in players.iterate
			if (inflictor and inflictor.valid and inflictor.type == MT_PLAYER)
			and player.mo and player.mo.valid
			and ultimatemode
			and (target.flags & MF_ENEMY)
			    P_GivePlayerRings(inflictor.player, 2)
			end
		end
	end
end)


addHook("MobjDamage", function(target, inflictor, source, player)
	if inflictor.skin == "hypersonic"
		for player in players.iterate
			if (inflictor and inflictor.valid and inflictor.type == MT_PLAYER)
			and player.mo and player.mo.valid
			and (target.flags & MF_BOSS)
			and ultimatemode
			    P_GivePlayerRings(inflictor.player, 4)
			end
		end
	end
end)


addHook("PlayerThink", function(player)
	local mo = player.mo
	if not All7Emeralds(emeralds) -- Means you don't have them all.
	and player.mo.skin == "hypersonic"
        and netgame
		and gametype == GT_COOP
			 CONS_Printf(player, "\x85"+"You need all 7 chaos emeralds before using Hyper Sonic!")
			 S_StartSound(player.mo, sfx_lose)
			 R_SetPlayerSkin(player, "sonic") -- Back to sonic duh.
         end
end)


addHook("PlayerThink", function(player)
	local mo = player.mo
    if (leveltime % 35 == 18)
	and not player.powers[pw_super]
	and not netgame
	and not splitscreen
	    and player.mo.skin == "hypersonic"
	    	P_GivePlayerRings(player, -1)
		end
end)


addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "hypersonic"
		if ultimatemode
			P_GivePlayerRings(player, 250)
		else
			P_GivePlayerRings(player, 25)
		end
	end	
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "hypersonic")
	and (p.pflags & PF_SPINNING)
	and (p.mo.state == S_PLAY_FLOAT)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin == "hypersonic"
			local strikesparkle = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-14, 13) *FixedMul(5, player.mo.scale),  P_RandomRange(-15, 14) * FRACUNIT, 9*FRACUNIT, MT_SUPERSPARK)
			strikesparkle.fuse = 5
			strikesparkle.scale = player.mo.scale * 20 / 23
			strikesparkle.momx = P_RandomRange(-14, 14) * FRACUNIT + FixedMul(-12, 12, player.mo.scale)
			strikesparkle.momy = P_RandomRange(-14, 14) * FRACUNIT + FixedMul(-12, 12, player.mo.scale)
			strikesparkle.momz = P_RandomRange(-8, 8) * FRACUNIT + FixedMul(-12, 12, player.mo.scale)
		end	
end)


addHook("PlayerThink", function(player)
    if player.mo.skin == "hypersonic"
		player.powers[pw_underwater] = 100*TICRATE
		player.powers[pw_spacetime] = 100*TICRATE
	 end
end)


// Hyper colors. 
freeslot(
"SKINCOLOR_HYPER1",
"SKINCOLOR_HYPER2",
"SKINCOLOR_HYPER3",
"SKINCOLOR_HYPER4",
"SKINCOLOR_HYPER5",
"SKINCOLOR_HYPER6",
"SKINCOLOR_HYPER7")

// Red Starts

skincolors[SKINCOLOR_HYPER1] = {
	name = "Hyper 1",
	ramp = {0,0,0,0,0,0,0,0,209,209,210,210,32,32,33,33},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Blue

skincolors[SKINCOLOR_HYPER2] = {
	name = "Hyper 2",
	ramp = {0,0,0,0,0,0,0,0,129,129,130,130,131,131,132,132},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Green

skincolors[SKINCOLOR_HYPER3] = {
	name = "Hyper 3",
	ramp = {0,0,0,0,0,0,0,0,98,98,99,99,100,100,101,101},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Yellow

skincolors[SKINCOLOR_HYPER4] = {
	name = "Hyper 4",
	ramp = {0,0,0,0,0,0,0,0,82,82,83,83,72,72,74,74},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// White

skincolors[SKINCOLOR_HYPER5] = {
	name = "Hyper 5",
	ramp = {0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Violet

skincolors[SKINCOLOR_HYPER6] = {
	name = "Hyper 6",
	ramp = {0,0,0,0,0,0,0,0,160,160,161,161,162,162,163,163},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Red ending

skincolors[SKINCOLOR_HYPER7] = {
	name = "Hyper 7",
	ramp = {0,0,0,0,0,0,0,0,200,200,201,201,202,202,203,203},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}


freeslot(
"SKINCOLOR_HYPER")


skincolors[SKINCOLOR_HYPER] = {
    name = "Hyper",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    accessible = true
}


addHook("ThinkFrame", do
	skincolors[SKINCOLOR_HYPER].ramp = skincolors[SKINCOLOR_HYPER1 + abs( ( (leveltime >> 2) % 9) - 6)].ramp
end)